#!/usr/bin/env python

import sys
import pygtk
pygtk.require("2.0")
import gtk
import gtk.glade
import os
import gettext
from user import home
import webkit
import string

# i18n
gettext.install("mintwelcome", "/usr/share/linuxmint/locale")

class MintWelcome():
    def __init__(self):
        gladefile = "/usr/lib/linuxmint/mintWelcome/mintWelcome.glade"
        wTree = gtk.glade.XML(gladefile,"main_window")
        wTree.get_widget("main_window").set_title(_("User Guide"))
        wTree.get_widget("main_window").set_icon_from_file("/usr/share/linuxmint/logo.png")

        sys.path.append('/usr/lib/linuxmint/common')
        from configobj import ConfigObj
        config = ConfigObj("/etc/linuxmint/info")
        edition = config['EDITION']
        release = config['RELEASE']
        distrib_id = config['DISTRIB_ID']
        wTree.get_widget("main_window").connect("destroy", gtk.main_quit)
        browser = webkit.WebView()
        wTree.get_widget("scrolled_welcome").add(browser)
        browser.connect("button-press-event", lambda w, e: e.button == 3)
        subs = {}
        subs['release'] = "%s %s" % (distrib_id, release)
        subs['edition'] = edition
        subs['title'] = _("Welcome to COS")
        subs['welcome'] = _("Welcome and thank you for choosing COS. We hope you'll enjoy using it as much as we did designing it. The links below will help you get started with your new operating system. Have a great time and don't hesitate to send us your feedback.")
        subs['release_title'] = _("Release")
        subs['edition_title'] = _("Edition")
        subs['show'] = _("Show this dialog at startup")
        subs['close'] = _("Close")
        subs['info_1_1'] = _("info_1_1")
        subs['info_1_2'] = _("info_1_2")
        subs['info_2_1'] = _("info_2_1")
        subs['info_2_2'] = _("info_2_2")
        subs['info_2_3'] = _("info_2_3")
        subs['info_3_1'] = _("info_3_1")
        subs['info_3_2'] = _("info_3_2")
        subs['info_4_1'] = _("info_4_1")
        subs['info_4_2'] = _("info_4_2")
        subs['info_4_3'] = _("info_4_3")
        subs['info_5_1'] = _("info_5_1")
        subs['info_5_2'] = _("info_5_2")
        subs['info_5_3'] = _("info_5_3")
        subs['event_1'] = _("event_1")
        subs['event_2'] = _("event_2")
        subs['event_3'] = _("event_3")
        subs['event_4'] = _("event_4")
        subs['event_5'] = _("event_5")
        subs['event_6'] = _("event_6")
        if os.path.exists(home + "/.linuxmint/mintWelcome/norun.flag"):
            subs['checked'] = ("")
        else:
            subs['checked'] = ("CHECKED")

        template = open("/usr/lib/linuxmint/mintWelcome/templates/welcome.html").read()
        html = string.Template(template).safe_substitute(subs)
        browser.load_html_string(html, "file:/")
        browser.connect('title-changed', self.title_changed)
        wTree.get_widget("main_window").show_all()

    def title_changed(self, view, frame, title):
        if title.startswith("nop"):
            return
        # call directive looks like:
        #  "call:func:arg1,arg2"
        #  "call:func"
        if title == "event_6":
            os.system("xdg-open file:///usr/share/nfs/help/html/help.htm")
        elif title == "event_close_true":
            if os.path.exists(home + "/.linuxmint/mintWelcome/norun.flag"):
                os.system("rm -rf " + home + "/.linuxmint/mintWelcome/norun.flag")
            gtk.main_quit()
        elif title == "event_close_false":
            os.system("mkdir -p " + home + "/.linuxmint/mintWelcome")
            os.system("touch " + home + "/.linuxmint/mintWelcome/norun.flag")
            gtk.main_quit()
        elif title == "checkbox_checked":
            if os.path.exists(home + "/.linuxmint/mintWelcome/norun.flag"):
                os.system("rm -rf " + home + "/.linuxmint/mintWelcome/norun.flag")
        elif title == "checkbox_unchecked":
            os.system("mkdir -p " + home + "/.linuxmint/mintWelcome")
            os.system("touch " + home + "/.linuxmint/mintWelcome/norun.flag")


if __name__ == "__main__":
    MintWelcome()
    gtk.main()
